Bug 6903 - APOP data coming from /dev/random
: APOP data coming from /dev/random
Status: CLOSED FIXED
: Sisyphus
(All bugs in Sisyphus/libsasl2)
: unstable
: all Linux
: P2 blocker
Assigned To:
:
:
:
:
:
  Show dependency tree
 
Reported: 2005-05-19 15:08 by
Modified: 2008-05-12 22:50 (History)


Attachments


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2005-05-19 15:08:15
Сервер.  Без клавиатуры-мыши.  cyrus-imapd с включеным APOP.

В один прекрасный момент обнаружилось что pop3 не работает вообще.  Долгие
выяснения причин привели к /dev/random из которого ничего не читалось. 
Естественных источников энтропии (таких как клавиатура и/или мышь) на сервере
нет и не планируется.  Отключение APOP помогло.

Есть мнение, что для APOP не нужны таки уж очень случайные числа, /dev/urandom
должно хватить (и он тоже читается!), особенно если принять, что на почтовых
серверах мыши и клавиатуры отсутствуют как класс.

Последние строки процесса в strace:

open("/dev/random", O_RDONLY)           = 10
read(10,  <unfinished ...>

14:09 <raorn> vsu: что могло с /dev/random случиццо?
14:09 <vsu> raorn: высосали из него всё...
14:10 <raorn> vsu: и что делать?
14:11 <vsu> 162 bytes (162 B) copied, 9,7423 seconds, 0,0 kB/s
14:11 <vsu> raorn: ждать, пока наберётся
14:12 <vsu> raorn: а без клавиатуры и мыши набирается весьма медленно
14:16 <vsu> raorn: багу повесь на этот цирроз
14:17 <vsu> raorn: с указанием в
http://www.modssl.org/docs/2.8/ssl_faq.html#random
------- Comment #1 From 2005-05-19 15:58:54 -------
При правах на /dev/random отличных от 600 умирает всё криптование в cyrus -
TLS,
CRAM-MD5...
------- Comment #2 From 2005-05-19 17:50:38 -------
насколько я понимаю, это лечится пересборкой с:   
--with-devrandom=/dev/urandom   
на "Сервер.  Без клавиатуры-мыши.  cyrus-imapd с включеным APOP." пересборка 
помогла. права на /dev/random вернул обратно на 644. всё работает.  
------- Comment #3 From 2005-05-21 11:56:17 -------
Весьма странно. У меня три сервера без клавиатуры-мыши с поддержкой pop3s/imaps
и таких проблем не возникало.

2.2.12-alt3 пересобран с /dev/urandom
------- Comment #4 From 2008-05-01 17:30:25 -------
Опять с /dev/random собрано. Кстати, а почему devel ?

$rpm -qf /usr/lib/libsasl2.so
libsasl2-devel-2.1.22-alt2
------- Comment #5 From 2008-05-01 17:32:52 -------
И перевешу заодно.
------- Comment #6 From 2008-05-01 17:41:22 -------
(In reply to comment #4)
> Кстати, а почему devel ?
> $rpm -qf /usr/lib/libsasl2.so

Всё правильно, у неё же SONAME есть.
------- Comment #7 From 2008-05-02 23:04:20 -------
> Всё правильно, у неё же SONAME есть.

Так soname у всех so есть, как я думал... :-)

Тут ещё момент непонятный - фраза "2.2.12-alt3 пересобран с /dev/urandom" от
2005г, когда, даже сейчас, всё ещё 2.1.x. Или это с Cyrus-IMAP попутана версия ?
------- Comment #8 From 2008-05-02 23:16:06 -------
(In reply to comment #7)
> > Всё правильно, у неё же SONAME есть.
> 
> Так soname у всех so есть, как я думал... :-)
Да, у всех. И у всех файлы *.so лежат в lib*-devel, что тут странного?
------- Comment #9 From 2008-05-03 00:45:58 -------
(In reply to comment #4)
> Опять с /dev/random собрано.

Возможно, стоит не пересобирать, а сделать зависимость на rng-tools и прописать
"chkconfig rngd on" в %post.
------- Comment #10 From 2008-05-04 08:40:14 -------
cyrus-sasl2 собран с /dev/random, cyrus-imapd - с /dev/urandom.
cyrus-sasl2 тоже соберу с /dev/urandom
------- Comment #11 From 2008-05-07 12:37:42 -------
Получается, что, раньше, cyrus-imapd сам туда лазил, а, теперь, через sasl ?
Вообще, rngd мне помог, с тех пор работает.
------- Comment #12 From 2008-05-12 22:50:17 -------
Fixed in 2.1.22-alt3.cvs.20080125